__author__ = 'oriol'
from mpl_toolkits.basemap import Basemap  # , cm, maskoceans
import matplotlib.pyplot as plt
from scipy.interpolate import interp1d
import numpy as np
import os

home = os.path.expanduser("~")
directory=home+"/visualisation_frames"

if not os.path.exists(directory):
    os.makedirs(directory)

# Import data from netCDF part
'''
#  from netCDF4 import Dataset as NetCDFFile
#  import numpy.ma as ma
# nc = NetCDFFile('/home/oriol/PythonMaps/sst_1m.nc')
# tmpvar = nc.variables["sst_1d_ave"]
# data = tmpvar[0][:]
# lons = nc.variables['nav_lon'][:]
# lats = nc.variables['nav_lat'][:]
'''

#  Functions
'''
def abs(x):
    if x < 0:
        x=-x
    return x
'''


def fit_longitude(x, limit=360):
    while x > limit:
        x -= 360
    return x


def fit_latitude(x, limit=90):
    while abs(x) > limit:
        if x > limit:
            x = 2*limit - x
        elif x < -limit:
            x = -2*limit - x
    return x


def create_transition(lat_0, lon_0, lat_1, lon_1, transition_time=10.0, init_time=2.0, finish_time=2.0, fps=20.0):
    total_time = transition_time+init_time+finish_time
    t = [0, init_time/2, init_time, init_time+transition_time,
         init_time+transition_time+finish_time/2,  init_time+transition_time+finish_time]
    lat = [lat_0, lat_0, lat_0, lat_1, lat_1, lat_1]
    lon = [lon_0, lon_0, lon_0, lon_1, lon_1, lon_1]
    flat = interp1d(t, lat, kind="cubic")
    flon = interp1d(t, lon, kind="cubic")
    tnew = np.linspace(0, total_time, total_time*fps)
    lat = flat(tnew)
    lon = flon(tnew)
    lat = map(fit_latitude, lat)
    lon = map(fit_longitude, lon)
    return tnew, lat, lon


latitudes = [42, -50, -40, 78]
longitudes = [2, -60, -220, -200]

frame = 0
total_frames = len(latitudes)*3*20
pi = 3.1415

for j in range(0, len(latitudes)):
    # Create smooth transition
    t, lat, lon = create_transition(latitudes[j], longitudes[j], latitudes[j+1], longitudes[j+1],
                                    init_time=0.5, transition_time=2, finish_time=0.5)
    # Transition values plot
    # plt.plot(t, lat, label="lat")
    # plt.plot(t, lon, label="lon")
    # plt.legend()
    # plt.show()
    for i in range(0, len(lon)):
        plt.figure(figsize=(2, 2))
        m = Basemap(projection='ortho', lon_0=lon[i], lat_0=lat[i],
        rsphere=6371200., resolution='l', area_thresh=10000)
        m.bluemarble(scale=0.1)
        plt.savefig(directory+"/"+"transition" + format(frame, '04') + '.jpeg')
        plt.clf()
        plt.close()
        print frame, "/", total_frames  # Print Progress
        frame += 1
        # plt.show()
'''
# Times and rotations
t = [0, 0.5, 1,  2, 3, 7, 8, 9, 9.5, 10]
r = [0, 0, 0,  0, 0, 360, 360, 360,  360, 360]
f2 = interp1d(t, r, kind='cubic')
# Duration and Frames per second
Duration = 10
xnew = np.linspace(min(t), max(t), Duration*FPS)
lon = f2(xnew)
lon = map(into_360,lon)
# 41.3881115,2.1146788
'''
# Plotting Data Part
'''
    # mdata = maskoceans(lons, lats, data, inlands=False, grid=1.25)
    # mask = ma.getmask(mdata)
    # mdata = ma.masked_array(data, np.logical_not(mask))
    # x, y = m(lons, lats)
    # x = ma.masked_array(x, np.logical_not(mask))
    # y = ma.masked_array(y, np.logical_not(mask))
    #  m.scatter(x, y, s=0.5, color='r', edgecolor="face", alpha=1)
    #  m.pcolor(x,y,mdata,edgecolor="face",alpha=1)
    #  m.pcolor(x,y,mdata,edgecolor="face",alpha=0.5/720*i)
'''